
def my_send(msg, to):
    msg_copy = copy.deepcopy(msg)
    msg_copy = replace(msg_copy, self, gateway)
    send((msg_copy, to), to=gateway, original_message=msg, original_to=to)

def my_send(msg, to):
    msg_copy = copy.deepcopy(msg)
    msg_copy = replace(msg_copy, self, gateway)
    send((msg_copy, to), to=gateway)

def replace(o,old,new):
    if hasattr(o, '__dict__'):
        for key, val in o.__dict__.items():
          if val == old:
            setattr(o, key, new)
          else:
            val = replace(val,old,new)

    elif isinstance(o, dict):
        for key, val in o.items():
          if val == old:
            o[key] = new
          else:
            val = replace(val,old,new)

    elif isinstance(o,tuple):
        tuple_list = list(o)
        for i in range(len(tuple_list)):
            if tuple_list[i] == old:
                tuple_list[i] = new
            else:
                tuple_list[i] = replace(tuple_list[i], old, new)
        o =  tuple(tuple_list)

    elif isinstance(o,list):
        for i in range(len(o)):
            if o[i] == old:
                o[i] = new
            else:
                o[i] = replace(o[i], old, new)

    elif isinstance(o,set):
        for item in o:
            if item == old:
                set.remove(item)
                set.add(new)
            else:
                item = replace(item, old, new)
    return o

# class member for yield number
self.yieldnum  = 0

# block==False means gateway should reply immediately if no message is available.
# block==True and timeout==None means gateway should reply only when a message is available.
# block==True and timeout != None means gateway should reply when a message is available or timeout has elapsed.
def my_yield(block, timeout):
    self.yieldnum += 1
    send(('yield', yieldnum, block, timeout), to= gateway)
    # from_ = gateway is unnecesary
    await(received(('resume', yieldnum), from_= gateway))

# for replacing labels not associated with an await statement
my_yield(False,None)

# for replacing simple await statements
while not(C): my_yield(True,None)

# for replacing await statements with multiple conditions and no timeout
while not(C1 or C2 or C3): my_yield(True,None)
# The following lines will be added programmatically
# if C1: stmt_1
# elif C2: stmt_2
# elif C3: stmt_2
# else: assert(false)

# for replacing await statements with timeout
start_time = time.time()
while not(C1 or ... or Cn):
  elapsed = time.time() - start_time
  remaining = t - elapsed
  if remaining <= 0:
      break
  my_yield(True,remaining)
# the following lines will be added programmaticallys
# if C1: stmt_1
# elif Cn: stmt_n
# else stmt_tmout